
# Check if string slicing works.
# Check slices [0:0], [0:1], [1:4], [0:-1], [3:-1], [2:1]

STRING

str:	"abcde"

CODE

	icopy	str, r0		# r0->"abcde"
	icopy	1, r1
	icopy	2, r2

	scopy	[r0], [r1]	# r1->"abcde"
	sslice	0, 0, [r1]	# r1[0:0] == ""
	slen	[r1], [r2]	# length
	iprint	[r2]		# 0

	scopy	[r0], [r1]	# r1->"abcde"
	sslice	0, 1, [r1]	# r1[0:1] == "a"
	slen	[r1], [r2]	# length
	iprint	[r2]		# 1
	sindex	0, [r1], [r2]	# r1[0]
	sprint	[r2]		# 4

	scopy	[r0], [r1]	# r1->"abcde"
	sslice	1, 4, [r1]	# r1[1:4] == "bcd"
	slen	[r1], [r2]	# length
	iprint	[r2]		# 3
	sindex	0, [r1], [r2]	# r1[0]
	sprint	[r2]		# 5
	sindex	1, [r1], [r2]	# r1[1]
	sprint	[r2]		# 6
	sindex	2, [r1], [r2]	# r1[2]
	sprint	[r2]		# 7

	scopy	[r0], [r1]	# r1->"abcde"
	sslice	0, -1, [r1]	# r1[0:-1] == "abcd"
	slen	[r1], [r2]	# length
	iprint	[r2]		# 4
	sindex	0, [r1], [r2]	# r1[0]
	sprint	[r2]		# 4
	sindex	1, [r1], [r2]	# r1[1]
	sprint	[r2]		# 5
	sindex	2, [r1], [r2]	# r1[2]
	sprint	[r2]		# 6
	sindex	3, [r1], [r2]	# r1[3]
	sprint	[r2]		# 7

	scopy	[r0], [r1]	# r1->"abcde"
	sslice	3, -1, [r1]	# r1[3:-1] == "d"
	slen	[r1], [r2]	# length
	iprint	[r2]		# 1
	sindex	0, [r1], [r2]	# r1[0]
	sprint	[r2]		# 7

	scopy	[r0], [r1]	# r1->"abcde"
	sslice	2, 1, [r1]	# r1[2:1] == ""
	slen	[r1], [r2]	# length
	iprint	[r2]		# 0

	halt

