
# Check if arrays are reference types.

STRING

yes:	"yes, arrays are reference types in this virtual machine\n"
no:	"no, arrays are value types, not reference types\n"

CODE

	icopy	5, r5
	icopy	6, r6
	icopy	7, r7
	icopy	8, r8

	anew	[r5]			# r5 -> []
	anew	[r6]			# r6 -> []

	ainsert	0, [r6], [r5]		# r5 -> [r6]

	ainsert	0, 2, [r6]		# r6 -> [2], so r5 -> [[2]]

	aindex	0, [r5], [r7]		# r7 -> [2]
	aindex	0, [r7], [r8]		# r8 -> 2

	icmp	[r8], 2			# [r8] == 2 ?

	beq	success

failure:
	icopy	no, r10
	sprint	[r10]
	halt

success:
	icopy	yes, r10
	sprint	[r10]
	halt

