# string subtraction test

STRING

empty:	""
zero:	""
one:	"a"
two:	"bc"
three:	"def"
test1:	"testa"
test2:	"testbc"
test3:	"testdef"
test4:	"testab"
test5:	"testabc"
test6:	"testabcd"
test7:	"testabcde"
test8:	"testabcdef"
test9:	"xtesta"
nl:	"\n"

CODE

	icopy	empty, r0
	icopy	zero, r20
	icopy	one, r1
	icopy	two, r2
	icopy	three, r3
	icopy	test1, r11
	icopy	test2, r12
	icopy	test3, r13
	icopy	test4, r14
	icopy	test5, r15
	icopy	test6, r16
	icopy	test7, r17
	icopy	test8, r18
	icopy	test9, r19
	icopy	nl, r10

	ssub	[r20], [r20], [r0]	# "" - "" == ""
	sprint	[r0]
	sprint	[r10]

	ssub	[r20], [r11], [r0]	# "testa" - "" == "testa"
	sprint	[r0]
	sprint	[r10]

	ssub	[r11], [r20], [r0]	# "" - "testa" == ""
	sprint	[r0]
	sprint	[r10]

	ssub	[r1], [r11], [r0]	# "testa" - "a" = "test"
	sprint	[r0]
	sprint	[r10]

	ssub	[r11], [r1], [r0]	# "a" - "testa" = "a"
	sprint	[r0]
	sprint	[r10]

	ssub	[r2], [r12], [r0]	# "testbc" - "bc" = "test"
	sprint	[r0]
	sprint	[r10]

	ssub	[r12], [r2], [r0]	# "bc" - "testbc" = "bc"
	sprint	[r0]
	sprint	[r10]

	ssub	[r3], [r13], [r0]	# "testdef" - "def" = "test"
	sprint	[r0]
	sprint	[r10]

	ssub	[r13], [r3], [r0]	# "def" - "testdef" = "def"
	sprint	[r0]
	sprint	[r10]

	ssub	[r1], [r14], [r0]	# "testab" - "a" = "testab"
	sprint	[r0]
	sprint	[r10]

	ssub	[r2], [r14], [r0]	# "testab" - "bc" = "testab"
	sprint	[r0]
	sprint	[r10]

	ssub	[r2], [r15], [r0]	# "testabc" - "bc" = "testa"
	sprint	[r0]
	sprint	[r10]

	ssub	[r1], [r0], [r0]	# "testa" - "a" = "test"
	sprint	[r0]
	sprint	[r10]

	ssub	[r2], [r16], [r0]	# "testabcd" - "bc" = "testabcd"
	sprint	[r0]
	sprint	[r10]

	ssub	[r3], [r17], [r0]	# "testabcde" - "def" = "testabcde"
	sprint	[r0]
	sprint	[r10]

	ssub	[r3], [r18], [r0]	# "testabcdef" - "def" = "testabc"
	sprint	[r0]
	sprint	[r10]

	ssub	[r2], [r0], [r0]	# "testabc" - "bc" = "testa"
	sprint	[r0]
	sprint	[r10]

	ssub	[r1], [r0], [r0]	# "testa" - "a" = "test"
	sprint	[r0]
	sprint	[r10]

	ssub	[r0], [r0], [r0]	# "test" - "test" = ""
	sprint	[r0]
	sprint	[r10]

	ssub	[r19], [r11], [r0]	# "testa" - "xtesta" = "testa"
	sprint	[r0]
	sprint	[r10]

	halt

