
# Check if array indexing works.
# Check index -length-1, length, length+1
# These should all produce error messages to stderr, and not crash.

CODE

	icopy	0, r0
	icopy	1, r1

	anew	[r0]		# r0->[]

	ainsert	0, 4, [r0]
	ainsert	1, 5, [r0]
	ainsert	2, 6, [r0]
	ainsert	3, 7, [r0]
	ainsert	4, 8, [r0]	# r0->[4,5,6,7,8]

	aindex	-6, [r0], [r1]	# r0[-length-1]	error
	iprint	[r1]		# should never happen

	aindex	5, [r0], [r1]	# r0[length]
	iprint	[r1]		# should never happen

	aindex	6, [r0], [r1]	# r0[length+1]
	iprint	[r1]		# should never happen

	halt

