
# Check if array slicing works.
# Check slices [0:0], [0:1], [1:4], [0:-1], [3:-1], [2:1]

CODE

	icopy	0, r0
	icopy	1, r1
	icopy	2, r2

	anew	[r0]		# r0->[]

	ainsert	0, 4, [r0]
	ainsert	1, 5, [r0]
	ainsert	2, 6, [r0]
	ainsert	3, 7, [r0]
	ainsert	4, 8, [r0]	# r0->[4,5,6,7,8]

	acopy	[r0], [r1]	# r1->[4,5,6,7,8]
	aslice	0, 0, [r1]	# r1[0:0] == []
	alen	[r1], [r2]	# length
	iprint	[r2]		# 0

	acopy	[r0], [r1]	# r1->[4,5,6,7,8]
	aslice	0, 1, [r1]	# r1[0:1] == [4]
	alen	[r1], [r2]	# length
	iprint	[r2]		# 1
	aindex	0, [r1], [r2]	# r1[0]
	iprint	[r2]		# 4

	acopy	[r0], [r1]	# r1->[4,5,6,7,8]
	aslice	1, 4, [r1]	# r1[1:4] == [5,6,7]
	alen	[r1], [r2]	# length
	iprint	[r2]		# 3
	aindex	0, [r1], [r2]	# r1[0]
	iprint	[r2]		# 5
	aindex	1, [r1], [r2]	# r1[1]
	iprint	[r2]		# 6
	aindex	2, [r1], [r2]	# r1[2]
	iprint	[r2]		# 7

	acopy	[r0], [r1]	# r1->[4,5,6,7,8]
	aslice	0, -1, [r1]	# r1[0:-1] == [4,5,6,7]
	alen	[r1], [r2]	# length
	iprint	[r2]		# 4
	aindex	0, [r1], [r2]	# r1[0]
	iprint	[r2]		# 4
	aindex	1, [r1], [r2]	# r1[1]
	iprint	[r2]		# 5
	aindex	2, [r1], [r2]	# r1[2]
	iprint	[r2]		# 6
	aindex	3, [r1], [r2]	# r1[3]
	iprint	[r2]		# 7

	acopy	[r0], [r1]	# r1->[4,5,6,7,8]
	aslice	3, -1, [r1]	# r1[3:-1] == [7]
	alen	[r1], [r2]	# length
	iprint	[r2]		# 1
	aindex	0, [r1], [r2]	# r1[0]
	iprint	[r2]		# 7

	acopy	[r0], [r1]	# r1->[4,5,6,7,8]
	aslice	2, 1, [r1]	# r1[2:1] == []
	alen	[r1], [r2]	# length
	iprint	[r2]		# 0

	halt

