
# Test if a dadd(int,double,cell) instruction causes an error
# in the assembler or in the virtual machine.
# This should be an invalid instruction and should not assemble,
# and should not run inside the virtual machine.
# It should not cause a core dump either.

DOUBLE

thing:	0.0

CODE

	icopy	thing, r0
	dadd	1, [r0], [r0]		# deliberate error!
	dadd	r2, [r0], [r0]		# deliberate error!
	dadd	[r0], 3, [r0]		# deliberate error!
	dadd	[r0], r4, [r0]		# deliberate error!
	dprint	[r0]
	halt

