/*
 *  This program tests the speed of compiled Java code doing integer
 *  operations, by repeatedly doing a number of operations in a
 *  loop. The number of iterations is controlled by an integer
 *  variable read in from stdin. Change this number to a million or
 *  more, if you want a good speed test.
 *  Compile this program using javac, then use the unix 'time' command
 *  to see how long this code takes to run:
 *    time java intspeed < intspeed.in
 */

class intspeed {
	static String report = " was the result\n";

	public static void main(String args[])
	{
		int repeat;
		int r0, r1, r4;

		try {
			repeat = (int) System.in.read();
		} catch (java.io.IOException e) {
			return;
		}
		r0 = repeat;
		r1 = 0;
		r4 = 7;

		while (r1 < r0) {
			r4 = r4 / 2;
			r4 *= 15;
			r4 += repeat;
			r4 %= 11;

			r0 --;
		}

		System.out.print(r4);
		System.out.print(report);
	}
}
