#!/usr/local/bin/python
#
#  A program to demonstrate recursive functions.
#  This program calculates and prints the factorial of
#  a number, e.g. 9! = 9 x 8 x 7 x 6 x 5 x 4 x 3 x 2 x 1
#

import sys

def main():
	sys.stdout.write("Find the factorial of which number? ")
	num = int(sys.stdin.readline())
	result = factorial(num)
	sys.stdout.write("\nThe factorial of ")
	sys.stdout.write(str(num))
	sys.stdout.write(" is ")
	sys.stdout.write(str(result))
	sys.stdout.write("\n")

def factorial(i):
	if i <= 1:
		return 1
	return (i * factorial(i-1))

main()

